"""Inquisitor models."""

from typing import Generic, TypeVar

from pydantic import BaseModel

T = TypeVar("T")


class Error(BaseModel):
    """Operation error."""

    detail: str = ""


class Pagination(BaseModel):
    """Token pagination model."""

    next_page_token: str = ""
    items_left: int | None = None


class PaginatedList(BaseModel, Generic[T]):
    """Token paginated results."""

    results: list[T]
    pagination: Pagination | None = None
